﻿<?php
// MySQL database credentials
$servername = 'localhost';
$username = 'root';
$password = '';
$database = 'charon';

// Create a connection to the MySQL server
$conn = new mysqli($servername, $username, $password);

// Check the connection
if ($conn->connect_error) {
    die("Connection failed: " . $conn->connect_error);
}

// Create the database if it doesn't exist
$sql = "CREATE DATABASE IF NOT EXISTS $database";
$conn->query($sql);
$conn->select_db($database);

// Create the 'likes' table if it doesn't exist
$sql = "CREATE TABLE IF NOT EXISTS likes (
    id INT AUTO_INCREMENT PRIMARY KEY,
    user_hash VARCHAR(255),
    link_id VARCHAR(255)
)";
$conn->query($sql);

// Function to count link repetitions
function countLinkRepetitions($linkID, $conn)
{
    // Prepare the SQL statement
    $stmt = $conn->prepare("SELECT COUNT(*) as count FROM likes WHERE link_id = ?");
    $stmt->bind_param("s", $linkID);
    
    // Execute the query
    $stmt->execute();
    
    // Fetch the result
    $result = $stmt->get_result();
    $row = $result->fetch_assoc();
    
    // Return the count
    return $row['count'];
}

// Example usage
$linkID = '1';

// Count the repetitions for the link
$count = countLinkRepetitions($linkID, $conn);
echo "The link with ID $linkID repeats $count times in the 'likes' table.";

// Close the database connection
$conn->close();
?>
