﻿<?php

/*/

Get the links of a page including those with relative URLs

/*/

// Function to convert relative URLs to absolute URLs
function absoluteUrl($baseUrl, $relativeUrl) {
    $baseParts = parse_url($baseUrl);
    if (isset($baseParts['scheme']) && isset($baseParts['host'])) {
        $scheme = $baseParts['scheme'];
        $host = $baseParts['host'];
        $path = isset($baseParts['path']) ? rtrim($baseParts['path'], '/') : '';
        $relativeParts = parse_url($relativeUrl);
        
        if (isset($relativeParts['scheme'])) {
            return $relativeUrl;
        } elseif (isset($relativeParts['host'])) {
            return $scheme . '://' . $relativeUrl;
        } else {
            $path = rtrim($path, '/') . '/';
            $newUrl = $scheme . '://' . $host . $path . ltrim($relativeUrl, '/');
            return $newUrl;
        }
    }
    
    return $relativeUrl;
}

// Function to get all the "http" links from a web page and save them in an array
function getHttpLinks($url) {
    $html = file_get_contents($url);
    $dom = new DOMDocument;
    @$dom->loadHTML($html);

    $links = [];
    $anchors = $dom->getElementsByTagName('a');
    foreach ($anchors as $anchor) {
        $href = $anchor->getAttribute('href');
        if (strpos($href, 'http') === 0) {
            $links[] = $href;
        } else {
            $absoluteUrl = absoluteUrl($url, $href);
            if (strpos($absoluteUrl, 'http') === 0) {
                $links[] = $absoluteUrl;
            }
        }
    }

    return $links;
}

// URL of the web page to fetch the links from
$pageUrl = "";

// Get all the "http" links from the web page
$httpLinks = getHttpLinks($pageUrl);

// Output the results
foreach ($httpLinks as $link) {
    echo $link . "<br>";
}

?>
